import { StyleSheet } from 'react-native'
import { onePx, px2dp, size } from '../../utils';



const comStyles = StyleSheet.create({
    page: {
        position: 'relative',
        width: '100%',
        flex: 1,
        backgroundColor: '#fff'
    },

    pageDark: {
        position: 'relative',
        width: '100%',
        flex: 1,
        justifyContent: 'flex-start',
        alignItems: 'center',
        backgroundColor: '#f7f7f8',
        borderRadius: 1,
    },

    listContainer: {
        width: '100%',
        flex: 1,
    },

    listContent: {
        width: '100%',
        justifyContent: 'flex-start',
        alignItems: 'center',
        paddingBottom: px2dp(72),
    },

    formGroupContainer: {
        width: px2dp(350),
        backgroundColor: '#fff',
        borderWidth: onePx,
        borderColor: '#e9e9e9',
        borderRadius: px2dp(6),
        marginTop: px2dp(10),
        overflow: 'hidden',
        justifyContent: 'flex-start',
        alignItems: 'center'
    },

    formGroupContainerWithOutEnd: {
        width: px2dp(350),
        backgroundColor: '#fff',
        // borderTopWidth: onePx,
        // borderTopColor: '#e9e9e9',
        // borderLeftWidth: onePx,
        // borderLeftColor: '#e9e9e9',
        // borderRightWidth: onePx,
        // borderRightColor: '#e9e9e9',
        borderRadius: px2dp(6),
        // borderTopLeftRadius: px2dp(0),
        // borderTopRightRadius: px2dp(6),
        // borderBottomLeftRadius: px2dp(6),
        marginTop: px2dp(12),
        overflow: 'hidden',
        borderWidth: 0,
        borderColor: null
    },

    headerBtn: {
        paddingHorizontal: px2dp(13),
        height: size.head_height,
        justifyContent: 'center',
        alignItems: 'center',
        flexDirection: 'row',
    },

    headerRightIcon: {
        width: px2dp(18),
        height: px2dp(18),
        tintColor: '#fff',
    },

    headerBtnText: {
        fontSize: 16,
        color: '#fff'
    },

    emptyText: {
        fontSize: 16,
        color: '#ccc'
    }
})


export default comStyles;