import React from 'react';
import {
    SafeAreaView,
    ScrollView,
    StatusBar,
    StyleSheet,
    Text,
    Image,
    TouchableOpacity,
    View,
    ViewStyle
} from 'react-native';
import { px2dp } from '../../utils';


interface Props {
    width?: number
    style?: ViewStyle
}

interface State {
}

export default class KitDashBorderLine extends React.Component<Props, State> {
    constructor(props: Props) {
        super(props);
    };
    public dots = [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
         1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
         1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
        ];
    public readonly state: Readonly<State> = {
    };

    render() {
        const { width = px2dp(330), style = {}} = this.props;
        return (
            <View style={[styles.border,{width: width},style]}>
                {this.dots.map((ele, index) => {
                    return (
                        <View key={index + ''} style={styles.dot}></View>
                    )
                })}
            </View>
        )
    }
}

const styles = StyleSheet.create({
    border: {
        width: px2dp(350),
        height: 1,
        flexDirection: 'row',
        justifyContent: 'flex-start',
        alignItems: 'center',
        overflow: 'hidden'
    },

    dot: {
        width: px2dp(4),
        height: 1,
        borderBottomColor: '#e6e6e6',
        borderBottomWidth: 1,
        marginRight: px2dp(2)
    },
})