import React, { PureComponent } from 'react';
import { View, StyleSheet, Text } from 'react-native';
import { colors, px2dp, isIos, onePx } from './../../utils';

interface Props {
  style?: object,
  mode?: 'dark' | 'light',
  title?: string
}

export default class FootLine extends PureComponent<Props> {
  constructor(props: any) {
    super(props);
  }
  render() {
    const { mode, title } = this.props;
    return (
      <View style={[styles.endRow, this.props.style]}>
        <View style={[styles.endLine, mode === "light" ? { backgroundColor: '#fff' } : null]}></View>
        <Text style={[styles.title, mode === 'light' ? { color: '#fff' } : null]}>{title ? title : '已加载所有条目'}</Text>
        <View style={[styles.endLine, mode === "light" ? { backgroundColor: '#fff' } : null]}></View>
      </View>
    )
  }
}

const styles = StyleSheet.create({
  endRow: {
    height: px2dp(52),
    flexDirection: 'row',
    justifyContent: 'center',
    alignItems: 'center',
  },

  endLine: {
    width: px2dp(64),
    height: onePx,
    backgroundColor: '#ccc'
  },

  title: {
    fontSize: 12,
    color: '#999',
    marginHorizontal: px2dp(16)
  }
})