//@ts-nocheck
import React, { PureComponent } from 'react';
import { Animated, Easing } from 'react-native';
import { px2dp } from '../../utils';


interface Props {
  height?: number;
  width?: number;
  size?: number;
  tintColor?: string;
}

export default class LoadingImageKit extends PureComponent<Props> {

  static defaultProps = {
    height: 20,
    width: 20,
    tintColor: "#fff"
  }

  constructor(props) {
    super(props);
    this.fadeAnim = new Animated.Value(0);
  }

  componentDidMount () {
    Animated.loop(Animated.timing(
      this.fadeAnim,
      {
        duration: 2800,
        toValue: 1,
        easing: Easing.linear,
        useNativeDriver: true
      }
    )).start()
  }

  render () {
    const { width, height, tintColor = '#fff', size = px2dp(20) } = this.props;
    return (
      <Animated.Image style={[{
        transform: [{
          rotate: this.fadeAnim.interpolate({
            inputRange: [0, 1],
            outputRange: ["0deg", "360deg"]
          }),
        }],
        width: size,
        height: size,
        tintColor,
      },this.props.style]}
        source={require("./../../assets/icons/loading-icon.png")} />
    );
  }
}