import React, { PureComponent } from 'react';
import { View, StyleSheet, Text, ActivityIndicator } from 'react-native';
import { colors, px2dp, isIos, onePx } from './../../utils';

interface Props {
  style?: object
}

export default class KitLoadingMore extends PureComponent<Props> {
  constructor(props:any){
    super(props);
  }
  render () {
    return (
      <View style={styles.endRow}>
        <ActivityIndicator color={colors.themeColor} size={'small'}/>
        <Text style={styles.title}>正在加载更多</Text>
      </View>
    )
  }
}

const styles = StyleSheet.create({
  endRow: {
    height: px2dp(52),
    flexDirection: 'row',
    justifyContent: 'center',
    alignItems:'center',
  },

  endLine: {
    width: px2dp(52),
    height: onePx,
    backgroundColor:'#ccc'
  },

  title: {
    fontSize: 12,
    color:'#999',
    marginHorizontal: px2dp(16)
  }
})