import React from 'react';
import {
    StyleSheet,
    View,
} from 'react-native';
import LottieView from 'lottie-react-native';
import { colors, px2dp, size, statusBarHeight } from '../../utils';

interface Props {
    loadingText?: string
    needIntentTop?: boolean
    needPaddingBottom?: boolean
}

interface State {
}

export default class KitLoadingPage extends React.Component<Props, State> {
    constructor(props: Props) {
        super(props);
    };

    public readonly state: Readonly<State> = {
    };

    render() {
        const { loadingText = "努力加载中", needIntentTop = true, needPaddingBottom = true } = this.props;
        return (
            <View style={[styles.loadingContainer, !needIntentTop ? { top: 0 } : null, !needPaddingBottom ? { paddingBottom: 0 } : null]}>
                <LottieView
                    autoPlay
                    speed={2.5}
                    style={{ width: px2dp(72), height: px2dp(72)}}
                    source={require('./../../animated/page-loding.json')}
                />
            </View>
        )
    }
}

const styles = StyleSheet.create({
    loadingContainer: {
        position: 'absolute',
        top: statusBarHeight + size.head_height,
        left: 0,
        right: 0,
        width: '100%',
        height: '100%',
        backgroundColor: '#fff',
        justifyContent: 'center',
        alignItems: 'center',
        zIndex: 9999,
        paddingBottom: px2dp(180)
    }
})