import React from 'react';
import {
    SafeAreaView,
    ScrollView,
    StatusBar,
    StyleSheet,
    Text,
    Image,
    TouchableOpacity,
    View,
    DeviceEventEmitter
} from 'react-native';
import FastImage from 'react-native-fast-image';
import { navigate } from '../../NavigationService';
import { colors, px2dp, size } from '../../utils';

interface Props {
}

interface State {
}

export default class MapNewResearchBtn extends React.Component<Props, State> {
    constructor(props: Props) {
        super(props);
    };

    public readonly state: Readonly<State> = {
    };

    openNewResearch() {
        // navigate('Setting')
        const researchTypeList = [
            {
                name: "群落概况",
                type: 'communityProfileResearch',
                icon: null,
                active: true
            },
            {
                name: "实(全)测法",
                type: 'actualMeasurementResearch',
                icon: null,
                active: false
            },
            {
                name: "样方(圆)法",
                type: 'sampleSquareResearch',
                icon: null,
                active: false
            },
            {
                name: "样线(带)法",
                type: 'sampleLineResearch',
                icon: null,
                active: false
            },
        ]
        DeviceEventEmitter.emit('show-selete-research-type-toast', { key: 'MapNewResearchBtn', researchTypeList })
    };

    render() {
        return (
            <View style={styles.bottomBtnContainer}>
                <TouchableOpacity
                    style={styles.bottomBtn}
                    onPress={this.openNewResearch.bind(this)}
                >
                    <FastImage
                        source={require('./../../assets/icons/add-round-icon.png')}
                        style={{ width: px2dp(16), height: px2dp(16), marginRight: px2dp(3) }}
                        tintColor={'#fff'}
                        resizeMode={'contain'}
                    />
                    <Text style={{fontSize: 14, color: '#fff'}}>新增调查</Text>
                </TouchableOpacity>
            </View>
        )
    }
}

const styles = StyleSheet.create({
    bottomBtnContainer: {
        position: 'absolute',
        left: px2dp(126),
        bottom: px2dp(24) + size.tab_height,
        zIndex: 9999,
    },

    bottomBtn: {
        width: px2dp(120),
        height: px2dp(36),
        backgroundColor: colors.themeColor,

        elevation: 8,
        justifyContent: 'center',
        alignItems: 'center',
        borderRadius: px2dp(18),
        flexDirection: 'row',
    }
})