import React from 'react';
import {
    SafeAreaView,
    ScrollView,
    StatusBar,
    StyleSheet,
    Text,
    Image,
    TouchableOpacity,
    View,
} from 'react-native';
import { colors, px2dp, statusBarHeight } from './../../utils';

interface Props {
}

interface State {
}

const GpsLocationKeepKit = () => {
    return (
        <View style={styles.btnContainer}>
            <TouchableOpacity style={styles.btnContent}>
                <Text style={{fontSize: 14, color: '#555'}}>GPS连接中</Text>
                <Image style={styles.rightIcon} source={require('../../assets/icons/right-icon.png')}/>
            </TouchableOpacity>
        </View>
    )
}

const styles = StyleSheet.create({
    btnContainer: {
        position: 'absolute',
        top: statusBarHeight + px2dp(42),
        left: px2dp((375 - 96) /2),
        width: px2dp(96),
        height: px2dp(28),
        borderRadius: px2dp(14),
        backgroundColor: 'rgba(255,255,255,0.88)',
        zIndex: 999,
        borderColor: colors.borderColor,
        borderWidth:1 
    },

    btnContent: {
        width: '100%',
        height: '100%',
        flexDirection: 'row',
        justifyContent: 'center',
        alignItems: 'center'
    },

    rightIcon: {
        width: px2dp(12),
        height: px2dp(12),
        tintColor: '#555'
    }
})

export default GpsLocationKeepKit;