import React from 'react';
import {
    SafeAreaView,
    ScrollView,
    StatusBar,
    StyleSheet,
    Text,
    Image,
    TouchableOpacity,
    View,
    DeviceEventEmitter
} from 'react-native';
import FastImage from 'react-native-fast-image';
import { onePx, px2dp } from '../../utils';

interface Props {
}

interface State {
}

export default class MapTools extends React.Component<Props, State> {
    constructor(props: Props) {
        super(props);
    };

    public readonly state: Readonly<State> = {
    };

    focusCurrentLocation() {
        DeviceEventEmitter.emit('focus-current-location')
    };

    render() {
        return (
            [
                <View style={styles.toolBtn} key={'location-btn'}>
                    <TouchableOpacity 
                        style={styles.toolBtnContent}
                        onPress={this.focusCurrentLocation.bind(this)}
                    >
                        <FastImage source={require('./../../assets/icons/focus-icon.png')}
                            style={{ width: px2dp(24), height: px2dp(24) }}
                            tintColor={'#303133'}
                        />
                        <Text style={{fontSize: 10, marginTop: px2dp(1)}}>定位</Text>
                    </TouchableOpacity>
                </View>
            ]
        )
    }
}

const styles = StyleSheet.create({
    toolBtn: {
        width: px2dp(36),
        height: px2dp(48),
        backgroundColor: 'rgba(255,255,255, 0.88)',
        position: 'absolute',
        bottom: px2dp(120),
        left: px2dp(13),
        zIndex: 999,
        elevation: 8,
        borderRadius: px2dp(4),
        // borderWidth: onePx,
        // borderColor: '#eee'
    },

    toolBtnContent: {
        width: px2dp(36),
        height: px2dp(46),
        justifyContent: 'center',
        alignItems: 'center',
        paddingTop: px2dp(3)
    }
})