
import React from 'react';
import {
    SafeAreaView,
    ScrollView,
    StatusBar,
    StyleSheet,
    Text,
    Image,
    TouchableOpacity,
    View,
} from 'react-native';
import { openDrawer } from '../../NavigationService';
import { px2dp, statusBarHeight } from './../../utils';

interface Props {
    opendFilter?: Function
}

interface State {
}

export default class MapViewBaseTool extends React.Component<Props, State> {
    constructor(props: Props) {
        super(props);
    };

    public layoutRef = null;
    public hideAllMapKit = false;

    public readonly state: Readonly<State> = {
    };

    _opendFilter = () => {
        const { opendFilter } = this.props;
        opendFilter && opendFilter();
    };

    onPressMap() {
        if (this.hideAllMapKit) {
            this.layoutRef.setNativeProps({
                style: {
                    zIndex: 999
                }
            })
        } else {
            this.layoutRef.setNativeProps({
                style: {
                    zIndex: -999
                }
            })
        }
        this.hideAllMapKit = !this.hideAllMapKit;
    };

    render() {
        return (
            <View
                style={styles.container}
                ref={(c) => this.layoutRef = c}
            >
                {/* <TouchableOpacity
                    style={styles.btn}
                    onPress={this._opendFilter.bind(this)}
                >
                    <Image
                        resizeMode={'contain'}
                        style={styles.toolIcon}
                        source={require('./../../assets/icons/map-new-icon-search.png')}
                    />
                </TouchableOpacity> */}
                <TouchableOpacity
                    style={styles.btn}
                    onPress={() => openDrawer('tool-box', {}, px2dp(260))}
                >
                    <Image
                        resizeMode={'contain'}
                        style={styles.toolIcon}
                        source={require('./../../assets/icons/map-new-icon-tool.png')}
                    />
                </TouchableOpacity>
                <TouchableOpacity
                    style={styles.btn}
                    onPress={() => openDrawer('map-tool', {}, px2dp(260))}
                >
                    <Image
                        resizeMode={'contain'}
                        style={styles.toolIcon}
                        source={require('./../../assets/icons/map-new-icon-layer.png')}
                    />
                </TouchableOpacity>
            </View>
        )
    }
}

const styles = StyleSheet.create({
    container: {
        width: px2dp(36),
        height: px2dp(72),
        position: 'absolute',
        top: statusBarHeight + px2dp(42),
        right: px2dp(12),
        zIndex: 999,
        borderRadius: px2dp(4),
        backgroundColor: 'rgba(255,255,255,0.68)',
        paddingVertical: px2dp(2)
    },

    btn: {
        flex: 1,
        width: '100%',
        justifyContent: 'center',
        alignItems: 'center'
    },

    toolIcon: {
        width: px2dp(32),
        height: px2dp(32)
    }
})
