import React from 'react';
import {
    SafeAreaView,
    ScrollView,
    StatusBar,
    StyleSheet,
    Text,
    Image,
    TouchableOpacity,
    View,
} from 'react-native';
import Store from '../../utils/Store';
import { BjTypeAppConfig } from '../../utils/types';
import redux from './../../redux/store';
import { setAppConfig, setAutoUpload, setDeviceHeight, setIsNetConnect, setMapConfig, setUserMsg } from '../../redux/actiions';
import SQLite from 'react-native-sqlite-storage';
import initDataBaseFunc from '../../database/InitDataBase';

interface Props {
}

interface State {
}

export default class InitSqlite3Task extends React.PureComponent<Props, State> {
    constructor(props: Props) {
        super(props);
    };

    public readonly state: Readonly<State> = {
    };

    componentDidMount() {
        /********* 初始化App配置项 ***********/
        let defaultAppConfig: BjTypeAppConfig = {
            compressImage: false,       //是否压缩图片
            compressVoice: false,       //是否压缩语音
            communityProfileResearch: "QLGK",
            actualMeasurementResearch: "QCDC",
            sampleSquareResearch: "YFDC",
            sampleLineResearch: "YXDC",
        }
        Store.getJsonObject('appConfig')
            .then(res => {
                if (!res.wetlandResearchPlot) {
                    res = {
                        ...defaultAppConfig,
                        ...res
                    };
                }
                console.log("这是appConfig", res);
                redux.dispatch(setAppConfig(res));
                this.setState({ appConfig: res })
            })
            .catch(e => {
                redux.dispatch(setAppConfig(defaultAppConfig))
            });
        Store.getJsonObject('userMsg')
            .then(res => {
                console.log("首页恢复的用户信息是----", res)
                redux.dispatch(setUserMsg(res));
            })
            .catch(e => {

            });
        try {
            let dbMaster, dbSecond;
            dbSecond = SQLite.openDatabase({ name: "test.db", location: 'default' });
            dbMaster = SQLite.openDatabase({ name: "beijihua", createFromLocation: 1 },
                (db) => {
                    dbMaster.attach(
                        "test.db",
                        "beijihua",
                        () => {
                            console.log("Database attached successfully");
                            global.db = dbMaster;  //新
                            this.onOpenDB();
                        }, () => console.log("ERROR"))
                },
                (err) => console.log("Error on opening database 'second'", err)
            );
        } catch (e) {
            console.log("失败------", e)
            //TODO 上报异常
        };
    };

    onOpenDB() {
        console.log("onOpenDB--------->数据库打开成功")
        initDataBaseFunc && initDataBaseFunc();
    }


    render() {
        return (
            <>
            </>
        )
    }
}