import { BjTypeActualMeasurementResearch, BjTypeActualMeasurementResearchTableRow, BjTypeCommonResearch, BjTypeCommunityProfileResearch, BjTypeFastRecordV1, BjTypeFrequencyTableRow, BjTypeProtectionLandNameRow, BjTypeResearchConnection, BjTypeSampleLineResearch, BjTypeSampleSquareResearch, BjTypeSpeceisNameRow, BjTypeSpeciesBookTableRow } from "../utils/types";

const BjInstanceCommonResearch: BjTypeCommonResearch = {
    id: "",
    createUserId: "",
    createUserName: "",
    type: null,
    researchId: "",
    serialNumberAndCode: "",
    createDate: 0,
    updateDate: 0,
    deleteDate: 0,
    finishDate: 0,
    isLocalDelete: '0',
    altitudeStart: 0,
    latitudeStart: 0,
    longitudeStart: 0,
    geoType: 'GCJ-02',
    imageList: "",
    remark: "",
    targetSpeciesLiveType: "arbor",
    belongType: 'self'
};

const BjInstanceActualMeasurementResearch: BjTypeActualMeasurementResearch = {
    id: "",
    createUserId: "",
    createUserName: "",
    helpResearchNameStr: "",
    createDate: 0,
    editDate: 0,
    deleteDate: 0,
    finishDate: 0,
    poiAddress: "",
    serialNumberAndCode: "",
    customAddress: "",
    altitudeStart: 0,
    latitudeStart: 0,
    longitudeStart: 0,
    altitudeEnd: 0,
    latitudeEnd: 0,
    longitudeEnd: 0,
    geoType: 'GCJ-02',
    mapTypeName: "",
    researchAreaImageList: "",
    remark: "",
    isLocalDelete: "0",
    otherDeviceTakePhotoRemark: "",
}

const BjInstanceSampleSquareResearch: BjTypeSampleSquareResearch = {
    id: "",
    createUserId: "",
    createUserName: "",
    helpResearchNameStr: "",
    createDate: 0,
    editDate: 0,
    deleteDate: 0,
    finishDate: 0,
    poiAddress: "",
    serialNumberAndCode: "",
    customAddress: "",
    altitudeStart: 0,
    latitudeStart: 0,
    longitudeStart: 0,
    altitudeEnd: 0,
    latitudeEnd: 0,
    longitudeEnd: 0,
    geoType: 'GCJ-02',
    mapTypeName: "",
    researchAreaImageList: "",
    remark: "",
    isLocalDelete: "0",
    otherDeviceTakePhotoRemark: "",
    mainSampleSquareCode: "",  //主样方(圆)编号
    targetSpeciesLiveType: "arbor",  //目标物种生活型
    mainSampleSizeSettingType: 'sample-square',  //主样方(圆)大小设置
    sampleRoundRadius: "15",      //主样圆半径
    sampleSquareLong: "20",       //主样方长
    sampleSquareWidth: "20",      //主样方宽
    subSampleSquareMaxNum: "4",  //副样方(圆)数
    belongType: 'self'
}

const BjInstanceSampleLineResearch: BjTypeSampleLineResearch = {
    id: "",
    createUserId: "",
    createUserName: "",
    helpResearchNameStr: "",
    createDate: 0,
    editDate: 0,
    deleteDate: 0,
    finishDate: 0,
    poiAddress: "",
    serialNumberAndCode: "",
    customAddress: "",
    altitudeStart: 0,
    latitudeStart: 0,
    longitudeStart: 0,
    altitudeEnd: 0,
    latitudeEnd: 0,
    longitudeEnd: 0,
    geoType: 'GCJ-02',
    mapTypeName: "",
    researchAreaImageList: "",
    remark: "",
    isLocalDelete: "0",
    otherDeviceTakePhotoRemark: "",
    otherDeviceTrackLineRemark: "",
    mainSampleLineWidth: "",
    mainPassingPointAddress: "",
    localSampleSquareResearchConnectList: "",
    onlineSampleSquareResearchConnectList: "",
}

const BjInstanceCommunityProfileResearch: BjTypeCommunityProfileResearch = {
    id: "",
    createUserId: "",
    createUserName: "",
    helpResearchNameStr: "",
    insiderResearchNameStr: "",
    targetSpeciesNameList: "",
    otherDeviceTrackLineRemark: "",
    createDate: 0,
    editDate: 0,
    deleteDate: 0,
    finishDate: 0,
    poiAddress: "",
    serialNumberAndCode: "",
    customAddress: "",
    altitudeStart: 0,
    latitudeStart: 0,
    longitudeStart: 0,
    altitudeEnd: 0,
    latitudeEnd: 0,
    longitudeEnd: 0,
    geoType: 'GCJ-02',
    researchArea: "",
    spotProtectionCondition: "",  //就地保护状况
    protectionLandName: "",   //保护地名称
    protectionLandLevel: "",  //保护地级别
    communityName: "",  //群落名称
    communityArea: "",  //群落面积
    communityOrigin: "",  //群落起源
    communityIntegrity: "",  //群落完整性
    canopyDensity: "",  //郁闭度
    totalCoverage: "",  //总盖度
    bedrockName: "",   //基岩名称
    rockExposedRate: "",  //岩石裸露率
    slopeDgree: "",  //坡度
    slopeDirection: "",  //坡向
    slopePosition: "",  //坡位
    soilType: "",  //土壤类型
    soilThickness: "",  //土层厚度
    soilPH: "",  //土壤ph
    communityAppearanceImageList: "",
    communityInternalAppearanceImageList: "",
    otherDeviceTakePhotoRemark: "",
    remark: "",
    isLocalDelete: "0",
    scatteredIndividual: "",
    arborAdvantageSpeciesName: "",
    arborCompanionSpeciesName: "",
    shrubAdvantageSpeciesName: "",
    shrubCompanionSpeciesName: "",
    plantAdvantageSpeciesName: "",
    plantCompanionSpeciesName: "",
    interLayerAdvantageSpeciesName: "",
    interLayerCompanionSpeciesName: "",
};


const BjInstanceResearchConnection: BjTypeResearchConnection = {
    id: "",
    actualMeasurementResearchId: "",
    communityProfileResearchId: "",
    sampleSquareResearchId: "",
    sampleLineResearchId: "",
    createDate: 0,
};

const BjInstanceActualMeasurementResearchTableRow: BjTypeActualMeasurementResearchTableRow = {
    id: "",
    researchId: "",
    layerType: "other",
    extraLayerType: "unset",
    tabIndex: "0",
    serialNumberAndCode: "",
    speciesName: "",
    breastDiameter: "",
    heightUnderBranch: "",
    amplitudeCrown: "",
    amplitudeCrownLong: "",
    amplitudeCrownWidth: "",
    health: "",
    rootPartHabitat: "",  //
    isFlower: "",
    isFruit: "",
    numberOfClusters: "",  //丛数
    numberOfPlants: "",  //株数
    groundDiameter: "",  //地径cm
    plantHeight: "",  //高度
    averageCrownWidth: "", //平均冠幅
    coverage: "",  //盖度
    plantNumberSoilSurface: "",
    plantNumberStoneDitch: "",
    plantNumberStoneSurface: "",
    plantNumberHealth: "",
    plantNumberSubHealth: "",
    plantNumberMediumHealth: "",
    plantNumberNotHealth: "",
    plantNumberIsFlower: "",
    plantNumberIsFruit: "",
    plantNumberRockEpiphyte: "",
    plantNumberBranchEpiphyte: "",
    plantNumberOtherType: "",
    minGroundDiameter: "",
    averageGroundDiameter: "",
    maxGroundDiameter: "",
    minPlantHeight: "",
    averagePlantHeight: "",
    maxPlantHeight: "",
    remark: "",
    imageList: "",
    voiceList: "",
    altitude: 0,
    longitude: 0,
    latitude: 0,
    createDate: 0,
    editDate: 0,
    geoType: 'GCJ-02',
    isLocalDelete: '0',
    createUserId: "",
    createUserName: "",
};

const BjInstanceFrequencyTableRow: BjTypeFrequencyTableRow = {
    id: "",
    researchId: "",
    layerType: 'arbor',
    extraLayerType: 'unset',
    speciesName: "",
    frequencyValue: "",
    createDate: "",
    isLocalDelete: "0"
};

const BjInstanceSpeciesBookTableRow: BjTypeSpeciesBookTableRow = {
    id: "",
    researchId: "",
    layerType: 'arbor',
    extraLayerType: 'unset',
    speciesName: "",
    dispatchArea: "",  //分布面积
    locationTag: "",   //定位标记 多选+填写 | 固定标桩；永久磁铁；目的物种树干油漆标记；毗邻岩石油漆标记  
    dispatchLayer: "",  //分布层 多选   | 乔木层（林冠层）；下木层；灌木层；草本层；地被层；层间层 
    dispatchType: "",  //分布方式 |   随机型；集群型；均匀型
    liveType: "",   //生活型 多选 | 乔木；灌木；草本；藤本；常绿；落叶；一年生；多年生；木质；肉质
    updateType: "",  //更新方式 多选  | 种子实生；无性繁殖（如萌生、分蘖）；种子实生为主；无性繁殖为主
    mainThreatenFactors: "",   //多选+填写 主要威胁因素  | 生境退化或丧失；直接采挖或砍伐；自然灾害；环境污染；外来生物入侵；本地物种竞争；病虫害；自身特性限制
    peopleUseType: "",  //多选+填写  | 用材；药用；薪柴；观赏；食用；特殊用途：
    humanActivityType: "",  //人为干扰方式  | 采挖；砍伐；修枝；剥皮；开垦；修路；水库；旅游；城镇化；火灾；放牧；狩猎；开矿；污染；    
    humanInterfereRate: "", //人为干扰强度  |  强、中、弱、无
    protectionUrgency: "",
    //以下是未处理的字段
    actualMeasurementNumber: "", //实测点数量
    actualMeasurementSerialNumber: "",  //实测点编号
    speciesCenterLongitude: "",    //目的物种分布中心点GPS
    speciesCenterLatitude: "",     //目的物种分布中心点GPS
    speciesCenterAltitude: "",     //目的物种分布中心点GPS
    mainSampleSquareNumber: "",    //主样方(圆)数量
    mainSampleSquareSerialNumber: "",    //主样方(圆)编号
    mainSampleLineNumber: "",            //样线(带)数量
    mainSampleLineSerialNumber: "",      //样线(带)编号
    createDate: "",
    isLocalDelete: '0',
}

const BjInstanceProtectionLandNameRow: BjTypeProtectionLandNameRow = {
    id: "",
    protectionLandName: "",
    protectionLandCity: "",
    protectionLandCounty: "",
    protectionLandType: "",
    protectionLandLevel: "",
};

const BjInstanceFastRecordV1: BjTypeFastRecordV1 = {
    id: "",
    type: "humanActivity",
    title: "",
    imageList: "",
    voiceList: "",
    speciesName: "",  //物种名称
    speciesType: "",
    speciesCount: 0, //数量 
    microHabitat: "",
    remark: "",       //备注  
    customAddress: "",
    createDate: 0,
    createUserId: 0,
    createUserName: "",
    specimenAcquisitionNumber: "", //标本采集号
    serialNumber: "",  //编号
    updateDate: 0,
    altitude: "",
    latitude: "",
    longitude: "",
    locationPoiAddress: "",
    groupId: 0,
    interferenceType: "",
    interferenceRate: "",
    photoTag: "",
    url: "",  //图片库展示用
    extra: "",
    isLocalDelete: '0'
}

export {
    BjInstanceActualMeasurementResearch,
    BjInstanceCommunityProfileResearch,
    BjInstanceCommonResearch,
    BjInstanceResearchConnection,
    BjInstanceActualMeasurementResearchTableRow,
    BjInstanceSampleSquareResearch,
    BjInstanceSampleLineResearch,
    BjInstanceFrequencyTableRow,
    BjInstanceSpeciesBookTableRow,
    BjInstanceProtectionLandNameRow,
    BjInstanceFastRecordV1
}