
import DataBaseTableName from "./DataBaseTableName";
import { BjInstanceActualMeasurementResearch, BjInstanceActualMeasurementResearchTableRow, BjInstanceCommonResearch, BjInstanceCommunityProfileResearch, BjInstanceFastRecordV1, BjInstanceFrequencyTableRow, BjInstanceProtectionLandNameRow, BjInstanceResearchConnection, BjInstanceSampleLineResearch, BjInstanceSampleSquareResearch, BjInstanceSpeciesBookTableRow } from "./Instance";

const generateCreateTableSQL = (tableName: string, instance: Object) => {
    try {
        const { keys, values } = Object;
        const keyNameList = keys(instance);
        let statement = `CREATE TABLE IF NOT EXISTS ${tableName} (`;
        keyNameList.forEach((key, index) => {
            if (index < keyNameList.length - 1) {
                statement = statement + ` ${key},`
            } else {
                statement = statement + ` ${key} )`
            }
        })
        console.log("statement", statement)
        return statement;
    } catch (e) {
        console.log("generateCreateTableSQL-err", e)
        return null;
    }
};

const createCommonResearchTable = generateCreateTableSQL(
    DataBaseTableName.researchCommonTable,
    BjInstanceCommonResearch
);

const createResearchConnectionTable = generateCreateTableSQL(
    DataBaseTableName.researchConnectionTable,
    BjInstanceResearchConnection
);

const createActualMeasurementResearchTableSQL = generateCreateTableSQL(
    DataBaseTableName.actualMeasurementResearchTable,
    BjInstanceActualMeasurementResearch
);


const createcommunityProfileResearchTableSQL = generateCreateTableSQL(
    DataBaseTableName.communityProfileResearchTable,
    BjInstanceCommunityProfileResearch
)

const createActualMeasurementResearchSubTableSQL = generateCreateTableSQL(
    DataBaseTableName.actualMeasurementResearchSubTable,
    BjInstanceActualMeasurementResearchTableRow
)

//样方(圆)
const createSampleSquareResearchTableSQL = generateCreateTableSQL(
    DataBaseTableName.sampleSquareResearchTable,
    BjInstanceSampleSquareResearch
)

//样方(圆)- 数据表
const createSampleSquareResearchSubTableSQL = generateCreateTableSQL(
    DataBaseTableName.sampleSquareResearchSubTable,
    BjInstanceActualMeasurementResearchTableRow
)

//样线(带）
const createSampleLineResearchTableSQL = generateCreateTableSQL(
    DataBaseTableName.sampleLineResearchTable,
    BjInstanceSampleLineResearch
)

////样线(带）- 数据表
const createSampleLineResearchSubTableSQL = generateCreateTableSQL(
    DataBaseTableName.sampleLineResearchSubTable,
    BjInstanceActualMeasurementResearchTableRow
)


const createFrequencyTableSQL = generateCreateTableSQL(
    DataBaseTableName.frequencyTable,
    BjInstanceFrequencyTableRow
)

const createSpeciesBookTableSQL = generateCreateTableSQL(
   DataBaseTableName.speciesBookTable,
   BjInstanceSpeciesBookTableRow
)

const createProtectionLandTableSQL = generateCreateTableSQL(
    DataBaseTableName.protectionLandInfoTable,
    BjInstanceProtectionLandNameRow
 )


 const createNotBookTableSQL = generateCreateTableSQL(
    DataBaseTableName.nootBookTable,
    BjInstanceFastRecordV1
 )
 
export {
    createCommonResearchTable,
    createResearchConnectionTable,
    createActualMeasurementResearchTableSQL,
    createcommunityProfileResearchTableSQL,
    createActualMeasurementResearchSubTableSQL,
    createSampleSquareResearchTableSQL,
    createSampleSquareResearchSubTableSQL,
    createSampleLineResearchTableSQL,
    createSampleLineResearchSubTableSQL,
    createFrequencyTableSQL,
    createSpeciesBookTableSQL,
    createProtectionLandTableSQL,
    createNotBookTableSQL
}

