import React from 'react';
import {
    SafeAreaView,
    ScrollView,
    StatusBar,
    StyleSheet,
    Text,
    Image,
    TouchableOpacity,
    View,
    DeviceEventEmitter
} from 'react-native';
import { closeDrawer, navigate } from '../../NavigationService';
import { colors, onePx, px2dp, toast } from '../utils';


interface Props {
}

interface State {
}

export default class ToolBox extends React.Component<Props, State> {
    constructor(props: Props) {
        super(props);
    };

    public readonly state: Readonly<State> = {
    };

    handleAddMarker() {
        DeviceEventEmitter.emit('handle-add-marker');
        closeDrawer()
    };

    render() {
        return (
            <ScrollView
                style={{ width: '100%', backgroundColor: '#fff', flex: 1 }}
            >
                <View style={[styles.row,{height: px2dp(42)}]}>
                    <Text style={[styles.rowTitle, { fontSize: 18 }]}>工具</Text>
                </View>
                <TouchableOpacity 
                    style={styles.row}
                    onPress={() => navigate('UserCompassPage')}
                >
                    <View
                        style={styles.rowIconBox}
                    >
                        <Image
                            style={styles.rowIcon}
                            resizeMode={'contain'}
                            source={require('./../assets/icons/tool-box-icon-zhinan.png')}
                        />
                    </View>
                    <Text style={styles.rowTitle}>指南针</Text>
                </TouchableOpacity>
                {/* <TouchableOpacity 
                    style={styles.row}
                    onPress={this.handleAddMarker.bind(this)}
                >
                    <View
                        style={styles.rowIconBox}
                    >
                        <Image
                            style={styles.rowIcon}
                            resizeMode={'contain'}
                            source={require('./../assets/icons/tool-box-icon-xinqu.png')}
                        />
                    </View>
                    <Text style={styles.rowTitle}>兴趣点</Text>
                </TouchableOpacity> */}
                <TouchableOpacity 
                    style={styles.row}
                    onPress={() => navigate('SlopeLength')}
                >
                    <View
                        style={styles.rowIconBox}
                    >
                        <Image
                            style={styles.rowIcon}
                            resizeMode={'contain'}
                            source={require('./../assets/icons/tool-box-pochang.png')}
                        />
                    </View>
                    <Text style={styles.rowTitle}>坡长计算</Text>
                </TouchableOpacity>
                {/* <TouchableOpacity 
                    style={styles.row}
                    onPress={() => toast(commomNoticeMsg.notFinish)}
                >
                    <View
                        style={[styles.rowIconBox,{backgroundColor: 'red'}]}
                    >
                        <Image
                            style={styles.rowIcon}
                            resizeMode={'contain'}
                            source={require('./../assets/tool-box-icon-sos.png')}
                        />
                    </View>
                    <Text style={styles.rowTitle}>紧急呼叫</Text>
                </TouchableOpacity> */}
            </ScrollView>
        )
    }
}


const styles = StyleSheet.create({
    row: {
        width: '100%',
        height: px2dp(56),
        flexDirection: 'row',
        justifyContent: 'flex-start',
        alignItems: 'center',
        paddingHorizontal: px2dp(12),
        paddingTop: px2dp(6),
        marginBottom: px2dp(12)
    },

    rowTitle: {
        fontSize: 15,
        color: colors.blackColor
    },

    box: {
        width: '100%',
        backgroundColor: '#fff'
    },

    col: {
        width: '100%',
        flexDirection: 'column',
        justifyContent: 'flex-start',
        alignItems: 'center'
    },

    optionRow: {
        width: px2dp(232),
        height: px2dp(72),
        flexDirection: 'row',
        justifyContent: 'space-between',
        alignItems: 'center',
        borderTopColor: '#d2d2d2',
        borderTopWidth: onePx,
    },

    rowIconBox: {
        width: px2dp(38),
        height: px2dp(38),
        borderWidth: 2,
        borderColor: '#606266',
        borderRadius: px2dp(19),
        justifyContent: 'center',
        alignItems: 'center',
        marginRight: px2dp(12)
    },

    optionRowLeft: {
        height: '100%',
        flexDirection: 'row',
        justifyContent: 'flex-start',
        alignItems: 'center',
    },

    mapTypeBoxContainer: {
        width: '100%',
        flexDirection: 'row',
        justifyContent: 'space-between',
        alignItems: 'center',
        paddingHorizontal: px2dp(12),
        paddingVertical: px2dp(12)
    },

    mapTypeBox: {
        position: 'relative',
        width: px2dp(112),
        justifyContent: 'center',
        alignItems: 'center',
    },

    mapTypeImgBox: {
        width: px2dp(112),
        height: px2dp(88),
        position: 'relative',
        borderWidth: 1,
        borderColor: 'rgba(0,0,0,0)',
        overflow: 'hidden',
        marginBottom: px2dp(6),
        borderRadius: px2dp(2)
    },

    mapTypeImg: {
        width: px2dp(112),
        height: px2dp(88),
        borderColor: colors.borderColor,
        borderWidth: onePx,
    },

    mapCheckedRow: {
        position: 'absolute',
        left: 0,
        bottom: 0,
        width: '100%',
        height: px2dp(18),
        zIndex: 999,
        backgroundColor: colors.themeColor,
        justifyContent: 'center',
        alignItems: 'center'
    },

    mapCheckedIcon: {
        width: px2dp(18),
        height: px2dp(18),
        tintColor: '#FFF'
    },

    rowIcon1: {
        width: px2dp(44),
        height: px2dp(44),
        borderRadius: px2dp(22)
    },

    rowIcon: {
        width: px2dp(38),
        height: px2dp(38),

    },

    optionBtn: {
        height: '100%',
        justifyContent: 'center',
        alignItems: 'center',
        paddingHorizontal: px2dp(12)
    },

    optionRightIcon: {
        width: px2dp(28),
        height: px2dp(28),
        tintColor: '#909399'
    },

    iconBorder: {
        width: px2dp(48),
        height: px2dp(48),
        borderRadius: px2dp(24),
        borderWidth: 2,
        borderColor: '#909399',
        justifyContent: 'center',
        alignItems: 'center',
        marginHorizontal: px2dp(6)
    },
})

