import { BjTypeSheetOption } from "./types";


const spotProtectionConditionOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "国家公园"
    },
    {
        key: 2,
        name: "自然保护区"
    },
    {
        key: 3,
        name: "保护小区"
    },
    {
        key: 4,
        name: "森林公园"
    },
    {
        key: 5,
        name: "湿地公园"
    },
    {
        key: 6,
        name: "地质公园"
    },
    {
        key: 7,
        name: "风景名胜区"
    },
    {
        key: 8,
        name: "水源保护区"
    },
    {
        key: 9,
        name: "风水林"
    },
    {
        key: 10,
        name: "当地神树"
    },
    {
        key: 11,
        name: "古树名木类"
    },
    {
        key: 12,
        name: "村规民约保护"
    },
    {
        key: 13,
        name: "挂牌保护"
    },
    {
        key: 14,
        name: "挂牌保护"
    },
    {
        key: 15,
        name: "无保护"
    },

]

//国家级/省级/无级别
const protectionLandLevelOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "国家级"
    },
    {
        key: 2,
        name: "省级"
    },
    {
        key: 3,
        name: "无级别"
    }
]

const communityNameOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "群落名称1"
    },
    {
        key: 2,
        name: "群落名称2"
    },
    {
        key: 3,
        name: "群落名称3"
    }
]


//原生植被；次生植被；半人工植被；人工植被
const communityOriginOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "原生植被"
    },
    {
        key: 2,
        name: "次生植被"
    },
    {
        key: 3,
        name: "半人工植被"
    },
    {
        key: 4,
        name: "人工植被"
    }
]


//完整；少量破碎化；中等破碎化；严重破碎化
const communityIntegrityOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "完整"
    },
    {
        key: 2,
        name: "少量破碎化"
    },
    {
        key: 3,
        name: "中等破碎化"
    },
    {
        key: 4,
        name: "严重破碎化"
    }
]


//平坡：0-5度：缓坡：6-15度；斜坡：16-25度；陡坡：26-35度；急坡：36-45度；险坡：46度以上；悬崖：近90度。
const slopeDgreeOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "平坡：0-5度"
    },
    {
        key: 2,
        name: "缓坡：6-15度"
    },
    {
        key: 3,
        name: "斜坡：16-25度"
    },
    {
        key: 4,
        name: "陡坡：26-35度"
    },
    {
        key: 5,
        name: "急坡：36-45度"
    },
    {
        key: 6,
        name: "险坡：46度以上"
    },
    {
        key: 6,
        name: "悬崖：近90度"
    }
]


// 山顶；山脊；鞍部；中上部；中部；中下部；山脚；沟谷；平地
const slopePositionOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "山顶"
    },
    {
        key: 2,
        name: "山脊"
    },
    {
        key: 3,
        name: "鞍部"
    },
    {
        key: 4,
        name: "中上部"
    },
    {
        key: 5,
        name: "中部"
    },
    {
        key: 6,
        name: "中下部"
    },
    {
        key: 7,
        name: "山脚"
    },
    {
        key: 8,
        name: "沟谷"
    },
    {
        key: 9,
        name: "平地"
    }
]


//黄壤；石灰土；黄棕壤；红壤；红褐土；赤红壤；黄红壤；砖红壤性红壤；紫色土；山地草甸土；沼泽土；水稻土
const soilTypeOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "黄壤"
    },
    {
        key: 2,
        name: "石灰土"
    },
    {
        key: 3,
        name: "黄棕壤"
    },
    {
        key: 4,
        name: "红壤"
    },
    {
        key: 5,
        name: "红褐土"
    },
    {
        key: 6,
        name: "赤红壤"
    },
    {
        key: 6,
        name: "砖红壤性红壤"
    },
    {
        key: 7,
        name: "紫色土"
    },
    {
        key: 8,
        name: "山地草甸土"
    },
    {
        key: 9,
        name: "沼泽土"
    },
    {
        key: 10,
        name: "水稻土"
    }
]


//健康、亚健康、中健康、不健康
const healthTypeOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "健康"
    },
    {
        key: 2,
        name: "亚健康"
    },
    {
        key: 3,
        name: "中健康"
    },
    {
        key: 4,
        name: "不健康"
    }
]


//土面；石沟；石面 
const rootPartHabitatOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "土面"
    },
    {
        key: 2,
        name: "石沟"
    },
    {
        key: 3,
        name: "石面"
    }
]

const booleanOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "是"
    },
    {
        key: 2,
        name: "否"
    }
]

//定位标记
const locationTagOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "固定标桩"
    },
    {
        key: 2,
        name: "永久磁铁"
    },
    {
        key: 3,
        name: "目的物种树干油漆标记"
    },
    {
        key: 4,
        name: "毗邻岩石油漆标记"
    },
]

const dispatchLayerOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "乔木层（林冠层）"
    },
    {
        key: 2,
        name: "下木层"
    },
    {
        key: 3,
        name: "灌木层"
    },
    {
        key: 4,
        name: "草本层"
    },
]


const dispatchTypeOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "随机型"
    },
    {
        key: 2,
        name: "集群型"
    },
    {
        key: 3,
        name: "均匀型"
    }
]


const liveTypeOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "乔木"
    },
    {
        key: 2,
        name: "灌木"
    },
    {
        key: 3,
        name: "草本"
    },
    {
        key: 4,
        name: "藤本"
    },
    {
        key: 5,
        name: "常绿"
    },
    {
        key: 6,
        name: "落叶"
    },
    {
        key: 7,
        name: "一年生"
    },
    {
        key: 8,
        name: "多年生"
    },
    {
        key: 9,
        name: "木质"
    },
    {
        key: 10,
        name: "肉质"
    }
]


const updateTypeOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "种子实生"
    },
    {
        key: 2,
        name: "无性繁殖（如萌生、分蘖）"
    },
    {
        key: 3,
        name: "种子实生为主"
    },
    {
        key: 4,
        name: "无性繁殖为主"
    }
]

const mainThreatenFactorsOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "生境退化或丧失"
    },
    {
        key: 2,
        name: "直接采挖或砍伐"
    },
    {
        key: 3,
        name: "自然灾害"
    },
    {
        key: 4,
        name: "环境污染"
    },
    {
        key: 5,
        name: "外来生物入侵"
    },
    {
        key: 6,
        name: "本地物种竞争"
    },
    {
        key: 7,
        name: "病虫害"
    },
    {
        key: 8,
        name: "自身特性限制"
    }
]


const peopleUseTypeOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "用材"
    },
    {
        key: 2,
        name: "药用"
    },
    {
        key: 3,
        name: "薪柴"
    },
    {
        key: 4,
        name: "观赏"
    },
    {
        key: 5,
        name: "食用"
    },
    {
        key: 6,
        name: "特殊用途"
    }
]


const humanActivityTypeOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "采挖"
    },
    {
        key: 2,
        name: "修枝"
    },
    {
        key: 3,
        name: "剥皮"
    },
    {
        key: 4,
        name: "开垦"
    },
    {
        key: 5,
        name: "修路"
    },
    {
        key: 6,
        name: "水库"
    },
    {
        key: 7,
        name: "旅游"
    },
    {
        key: 8,
        name: "城镇化"
    },
    {
        key: 9,
        name: "火灾"
    },
    {
        key: 10,
        name: "放牧"
    },
    {
        key: 11,
        name: "狩猎"
    },
    {
        key: 12,
        name: "开矿"
    },
    {
        key: 13,
        name: "污染"
    }
]

const humanInterfereRateOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "强"
    },
    {
        key: 2,
        name: "中"
    },
    {
        key: 3,
        name: "弱"
    },
    {
        key: 4,
        name: "无"
    }
]

const bedrockNameOptions : Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "石灰岩"
    },
    {
        key: 2,
        name: "白云岩"
    },
    {
        key: 3,
        name: "板岩"
    },
    {
        key: 4,
        name: "变余砂岩"
    },
    {
        key: 5,
        name: "砂页岩"
    },
    {
        key: 6,
        name: "硅质泥岩"
    },
    {
        key: 7,
        name: "硅质岩"
    },
    {
        key: 8,
        name: "砾岩"
    },
    {
        key: 9,
        name: "砂岩"
    },
    {
        key: 10,
        name: "粉砂岩"
    },
    {
        key: 11,
        name: "紫色砂页岩"
    },
    {
        key: 12,
        name: "砖红色泥岩"
    },
    {
        key: 13,
        name: "凝灰岩"
    },
    {
        key: 14,
        name: "花岗岩"
    }
]


// 紧迫性极高/重点关注（JG）；紧迫性高/需要关注（G）；紧迫性不高/适当关注（BG）；无危/无需关注（WW）

const protectionUrgencyOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "紧迫性极高/重点关注（JG）"
    },
    {
        key: 2,
        name: "紧迫性高/需要关注（G）"
    },
    {
        key: 3,
        name: "紧迫性不高/适当关注（BG）"
    },
    {
        key: 4,
        name: "紧迫性不高/适当关注（BG）"
    },
    {
        key: 5,
        name: "无危/无需关注（WW）"
    }
];


// 林缘、路旁、耕地边、房屋边、水边、荒地
const scatteredIndividualOptions: Array<BjTypeSheetOption> = [
    {
        key: 1,
        name: "林缘"
    },
    {
        key: 2,
        name: "路旁"
    },
    {
        key: 3,
        name: "耕地边"
    },
    {
        key: 4,
        name: "房屋边"
    },
    {
        key: 5,
        name: "水边"
    },
    {
        key: 6,
        name: "荒地"
    }
];

export {
    spotProtectionConditionOptions,
    protectionLandLevelOptions,
    communityNameOptions,
    communityOriginOptions,
    communityIntegrityOptions,
    slopeDgreeOptions,
    slopePositionOptions,
    soilTypeOptions,
    healthTypeOptions,
    rootPartHabitatOptions,
    booleanOptions,
    locationTagOptions,
    dispatchLayerOptions,
    humanInterfereRateOptions,
    humanActivityTypeOptions,
    peopleUseTypeOptions,
    mainThreatenFactorsOptions,
    updateTypeOptions,
    liveTypeOptions,
    dispatchTypeOptions,
    bedrockNameOptions,
    protectionUrgencyOptions,
    scatteredIndividualOptions
}