// import API from "../api";
import API from "../api";
import DataBaseTableName from "../database/DataBaseTableName";
import { BjTypeResearchNameDict } from "./types";


/**
 * 接口适配器
 * @param type 业务类型
 * @param optionType 操作类型
 */
const adaptAPIAndName = (
    type: BjTypeResearchNameDict,
    optionType: 'option' | 'delete' | 'mutiple-delete' | 'query',
    dataType?: 'research-data' | 'row-data' | 'extra-row-data'
) => {
    let resultAPI = null;
    let tableName = "";
    switch (type) {
        //兽类样线
        case 'actualMeasurementResearch':
            if (dataType == 'research-data') {
                tableName = DataBaseTableName.actualMeasurementResearchTable;
                switch (optionType) {
                    case 'option':
                        resultAPI = API.optionActualMeasurementResearchV1;
                        break;
                    case 'delete':
                        // resultAPI = API.deleteCommonResearchListV1;
                        break;
                    case 'query':
                        resultAPI = API.getActualMeasurementResearchDetailstV1;
                        break;
                    default:
                        break;
                }
            } else if (dataType == 'row-data') {
                // tableName = DataBaseTableName.actualMeasurementResearchTable;
                switch (optionType) {
                    case 'option':
                        // resultAPI = API.optionBeastResearchLineTableRowV1;
                        break;
                    case 'delete':
                        // resultAPI = API.deleteBeastResearchLineTableRowV1;
                        break;
                    case 'query':
                        // resultAPI = API.getBeastResearchLineTableRowListV1;
                        break;
                    default:
                        break;
                }
            }
            break;
        //communityProfileResearch
        case 'communityProfileResearch':
            if (dataType == 'research-data') {
                tableName = DataBaseTableName.communityProfileResearchTable;
                switch (optionType) {
                    case 'option':
                        resultAPI = API.optionCommunityProfileResearchV1;
                        break;
                    case 'delete':
                        // resultAPI = API.deleteCommonResearchListV1;
                        break;
                    case 'query':
                        resultAPI = API.getCommunityProfileResearchDetailstV1;
                        break;
                    default:
                        break;
                }
            } else if (dataType == 'row-data') {
                // tableName = DataBaseTableName.researcBeastPointSubTable;
                switch (optionType) {
                    case 'option':
                        // resultAPI = API.optionBeastResearchPointTableRowV1;
                        break;
                    case 'delete':
                        // resultAPI = API.deleteBeastResearchPointTableRowV1;
                        break;
                    case 'query':
                        // resultAPI = API.getBeastResearchPointTableRowListV1;
                        break;
                    default:
                        break;
                }
            }
            break;
        //sampleSquareResearch
        case 'sampleSquareResearch':
            if (dataType == 'research-data') {
                tableName = DataBaseTableName.sampleSquareResearchTable;
                switch (optionType) {
                    case 'option':
                        resultAPI = API.optionSampleSquareResearchV1;
                        break;
                    case 'delete':
                        // resultAPI = API.deleteCommonResearchListV1;
                        break;
                    case 'query':
                        resultAPI = API.getSampleSquareResearchDetailstV1;
                        break;
                    default:
                        break;
                }
            } else if (dataType == 'row-data') {
                // tableName = DataBaseTableName.researcBeastPointSubTable;
                switch (optionType) {
                    case 'option':
                        // resultAPI = API.optionBeastResearchPointTableRowV1;
                        break;
                    case 'delete':
                        // resultAPI = API.deleteBeastResearchPointTableRowV1;
                        break;
                    case 'query':
                        // resultAPI = API.getBeastResearchPointTableRowListV1;
                        break;
                    default:
                        break;
                }
            }
            break;
        //sampleLineResearch
        case 'sampleLineResearch':
            if (dataType == 'research-data') {
                tableName = DataBaseTableName.sampleLineResearchTable;
                switch (optionType) {
                    case 'option':
                        resultAPI = API.optionSampleLineResearchV1;
                        break;
                    case 'delete':
                        // resultAPI = API.deleteCommonResearchListV1;
                        break;
                    case 'query':
                        resultAPI = API.getSampleLineResearchDetailstV1;
                        break;
                    default:
                        break;
                }
            } else if (dataType == 'row-data') {
                // tableName = DataBaseTableName.researcBeastPointSubTable;
                switch (optionType) {
                    case 'option':
                        // resultAPI = API.optionBeastResearchPointTableRowV1;
                        break;
                    case 'delete':
                        // resultAPI = API.deleteBeastResearchPointTableRowV1;
                        break;
                    case 'query':
                        // resultAPI = API.getBeastResearchPointTableRowListV1;
                        break;
                    default:
                        break;
                }
            }
            break;
        default:
            break;
    }
    return {
        resultAPI,
        name: "",
        tableName
    };
};




export {
    adaptAPIAndName
}