

interface BjTypeLocation {
    accuracy?: number
    adCode?: number
    address?: string
    city?: string
    cityCode?: string
    coordinateType?: string
    country?: string
    description?: string
    district?: string
    altitude?: number
    latitude?: number
    _latitude?: number
    longitude?: number
    _longitude?: number
    poiName?: string
    province?: string
    speed?: number
    street?: string
    timestamp?: number
}

interface BjTypeMapConfig {
    layerType: 'outdoor' | 'satellite',
    showVe: boolean,
    showVeLabel: boolean,
    showRiver: boolean,
    showRiverLabel: boolean,
    showResearchLine: boolean,
    showResearchPlot: boolean,
    showGridLine?: boolean,
    showResearchData?: boolean,
    showTrackLine?: boolean
    showResearchDataLabel?: boolean
}

interface BjTypeSheetOption {
    name: string
    key: number
    value?: string | number
    disable?: boolean
    checked?: boolean
};

interface BjTypeImage {
    id?: string
    name?: string
    url?: string //线上路径
    imagePath?: string //本地路径
    imageCopyPath?: string
    progress?: number
};

interface BjTypeActualMeasurementResearch {
    id: string
    createUserId?: string
    createUserName?: string
    poiAddress?: string
    helpResearchNameStr?: string
    createDate?: number
    editDate?: number
    deleteDate?: number
    finishDate?: number
    serialNumberAndCode?: string
    customAddress?: string
    altitudeStart?: number
    latitudeStart?: number
    longitudeStart?: number
    altitudeEnd?: number
    latitudeEnd?: number
    longitudeEnd?: number
    geoType?: 'WGS-84' | 'GCJ-02'
    mapTypeName?: string
    researchAreaImageList?: string
    remark?: string
    isLocalDelete: '0' | '1'
    otherDeviceTakePhotoRemark?: string
    belongType?: 'self' | 'sample-line'
};


interface BjTypeSampleSquareResearch {
    id: string
    createUserId?: string
    createUserName?: string
    helpResearchNameStr?: string
    createDate?: number
    editDate?: number
    deleteDate?: number
    finishDate?: number
    poiAddress?: string
    serialNumberAndCode?: string
    customAddress?: string
    altitudeStart?: number
    latitudeStart?: number
    longitudeStart?: number
    altitudeEnd?: number
    latitudeEnd?: number
    longitudeEnd?: number
    geoType?: 'WGS-84' | 'GCJ-02'
    mapTypeName?: string
    researchAreaImageList?: string
    remark?: string
    isLocalDelete: '0' | '1'
    otherDeviceTakePhotoRemark?: string
    mainSampleSquareCode?: string  //主样方(圆)编号
    targetSpeciesLiveType?: 'arbor' | 'shrub' | 'plant' | 'moss'  //目标物种生活型
    mainSampleSizeSettingType?: 'sample-round' | 'sample-square'  //主样方(圆)大小设置
    sampleRoundRadius?: string      //主样圆半径
    sampleSquareLong?: string       //主样方长
    sampleSquareWidth?: string      //主样方宽
    subSampleSquareMaxNum?: string  //副样方(圆)数
    belongType?: 'self' | 'sample-line'
};


interface BjTypeSampleLineResearch {
    id: string
    createUserId?: string
    createUserName?: string
    helpResearchNameStr?: string
    createDate?: number
    editDate?: number
    deleteDate?: number
    finishDate?: number
    serialNumberAndCode?: string
    customAddress?: string
    altitudeStart?: number
    latitudeStart?: number
    longitudeStart?: number
    altitudeEnd?: number
    latitudeEnd?: number
    longitudeEnd?: number
    geoType?: 'WGS-84' | 'GCJ-02'
    mapTypeName?: string
    poiAddress?: string
    researchAreaImageList?: string
    remark?: string
    isLocalDelete: '0' | '1'
    otherDeviceTakePhotoRemark?: string
    mainPassingPointAddress?: string  //主要途经点
    otherDeviceTrackLineRemark?: string   //其他设备记录的轨迹编号
    mainSampleLineWidth?: string  //样线(带）宽(m) 
    localSampleSquareResearchConnectList?: string,  //[xxx,xxx]
    onlineSampleSquareResearchConnectList?: string   //[xxx,xxx]
    belongType?: 'self' | 'sample-line'
};

interface BjTypeCommunityProfileResearch {
    id: string
    createUserId?: string
    createUserName?: string
    helpResearchNameStr?: string
    insiderResearchNameStr?: string
    targetSpeciesNameList?: string
    otherDeviceTrackLineRemark?: string
    createDate?: number
    editDate?: number
    deleteDate?: number
    finishDate?: number
    poiAddress?: string
    serialNumberAndCode?: string
    customAddress?: string
    altitudeStart?: number
    latitudeStart?: number
    longitudeStart?: number
    altitudeEnd?: number
    latitudeEnd?: number
    longitudeEnd?: number
    geoType?: 'WGS-84' | 'GCJ-02'
    researchArea?: string
    spotProtectionCondition?: string  //就地保护状况
    protectionLandName?: string   //保护地名称
    protectionLandLevel?: string  //保护地级别
    communityName?: string  //群落名称
    communityArea?: string  //群落面积
    communityOrigin?: string  //群落起源
    communityIntegrity?: string  //群落完整性
    canopyDensity?: string  //郁闭度
    totalCoverage?: string  //总盖度
    bedrockName?: string   //基岩名称
    rockExposedRate?: string  //岩石裸露率
    slopeDgree?: string  //坡度
    slopeDirection?: string  //坡向
    slopePosition?: string  //坡位
    soilType?: string  //土壤类型
    soilThickness?: string  //土层厚度
    soilPH?: string  //土壤ph
    communityAppearanceImageList?: string
    communityInternalAppearanceImageList?: string
    otherDeviceTakePhotoRemark?: string
    remark?: string
    isLocalDelete: '0' | '1'
    belongType?: 'self' | 'sample-line'
    scatteredIndividual?: string
    arborAdvantageSpeciesName?: string
    arborCompanionSpeciesName?: string
    shrubAdvantageSpeciesName?: string
    shrubCompanionSpeciesName?: string
    plantAdvantageSpeciesName?: string
    plantCompanionSpeciesName?: string
    interLayerAdvantageSpeciesName?: string
    interLayerCompanionSpeciesName?: string
}

interface BjTypeAppConfig {
    compressImage?: boolean
    compressVoice?: boolean
    communityProfileResearch?: string
    actualMeasurementResearch?: string
    sampleSquareResearch?: string
    sampleLineResearch?: string
}

type BjTypeResearchNameDict = 'actualMeasurementResearch' | 'communityProfileResearch' | 'sampleSquareResearch' | 'sampleLineResearch';

interface BjTypeCommonResearch {
    id: string
    createUserId: string
    createUserName?: string
    type: BjTypeResearchNameDict
    researchId: string
    serialNumberAndCode: string
    createDate?: number
    updateDate?: number
    deleteDate?: number
    finishDate?: number
    isLocalDelete?: '0' | '1'
    altitudeStart?: number
    latitudeStart?: number
    longitudeStart?: number
    geoType?: 'WGS-84' | 'GCJ-02'
    imageList?: string
    remark?: string
    targetSpeciesLiveType?: 'arbor' | 'shrub' | 'plant' | 'moss'
    belongType?: 'self' | 'sample-line'
}

interface BjTypeUserMsg {
    userInfo: {
        token: string
        groupName: string
        groupId: string
        authCode: Array<any>
        headerImg: string
        avatar: string
        nickName: string
        tel: string
        userId: string
        id?: string
        username: string
        gender: string
        account: string
    }
}

interface BjTypeResearchConnection {
    id?: string
    actualMeasurementResearchId?: string
    communityProfileResearchId?: string
    sampleSquareResearchId?: string
    sampleLineResearchId?: string
    createDate?: number
}

interface BjTypeTabRoute {
    key: string
    title: string
};

interface BjTypeTableHeaderConfigCell {
    prop: string
    label: string
    width: number
    type: 'input' | 'text' | 'location' | 'image' | 'option' | 'voice' | 'picker' | 'adapt'
    labelType?: 'number' | 'string'
    valueType?: 'int' | 'flot1' | 'flot2' | 'flot3' | 'string'
    unit?: string
    checked?: boolean
    placeHolder?: string
};

interface BjTypeVoice {
    id?: string
    name?: string
    audioPath?: string
    audioCopyPath?: string
    voiceUrl?: string
    duration?: number
    recordEndDate?: number
    uploadProgress?: number
    fastrecordLocalId?: any
}

interface BjTypeResearchAuthResult {
    authLevel: 1 | 2 | 3 | 4
    editble: boolean
    disableNotice:
    "您不是该调查任务成员，无操作权限，仅支持查看数据"
    | "该调查已结束，您非该调查负责人，已不可继续操作该调查数据"
    | "该项目已完成，已不可继续操作该调查数据"
    | "权限系统异常，请联系管理员"
    | "生境调查已完成，不可继续修改生境数据"
    | "调查已完成，不可继续增加数据"
}


interface TypeBirdResearchLineV1 {
    id?: string
    serialNumberAndCode?: string
    createUserId?: string | number
    createUserName?: string
    helpResearchNameStr?: string
    customAddress?: string
    altitudeStart?: string | number
    latitudeStart?: string | number
    longitudeStart?: string | number
    altitudeEnd?: string | number
    latitudeEnd?: string | number
    longitudeEnd?: string | number
    researchArea?: string
    researchLineDistance?: string | number
    remark?: string
    habitatType?: string
    habitatSubType?: string
    buildPopulationSpecies?: string
    humanActivityInterfereType?: string
    humanActivityInterfereSubType?: string
    humanActivityInterfereRate?: string
    topography?: string
    slopePosition?: string
    slopeDirection?: string
    wethear?: string
    windSpeed?: string
    temperature?: string
    humidity?: string
    imageList?: string
    voiceList?: string
    createDate?: string | number
    finishDate?: string | number
    groupId?: string
    phenologicalPhase?: string
    slopeDgree?: string
    liveEnvDispatchFinishDate?: number
    researchLength?: string //植被样点用
    researchWidth?: string //植被样点用
}

//鸟类样线调查行数据类型
interface TypeBirdResearchLineTableRowV1 {
    id?: string
    researchId?: string
    speciesName?: string
    speciesCout?: string
    observationDistance?: string
    imageList?: string
    voiceList?: string
    specimenAcquisitionNumber?: string
    remark?: string
    altitude?: number
    longitude?: string | number
    latitude?: string | number
    createDate?: string
    editDate?: string
    isToBeIdentified?: 1 | 0
    identifiedSpeciesName?: string
    behaviorType?: string
    activeHeight?: string
    serialNumberAndCode?: string
    isLocalDelete?: '0' | '1'
    microHabitat?: string
    averageHeight?: string  //植物样线用
    maleNumber?: string     //雄性数量（鸟类样线、样点、分区直数）
    femaleNumber?: string   //雌性数量（鸟类样线、样点、分区直数）
    adultNumber?: string,   //成年数（鸟类样线、样点、分区直数）
    subadultNumber?: string //亚成年数（鸟类样线、样点、分区直数）
    larvaNumber?: string    //幼鸟数（鸟类样线、样点、分区直数）
    interfereType?: string  //干扰类型（鸟类样线、样点、分区直数）
    interfereRate?: string  //干扰水平（鸟类样线、样点、分区直数）
    habitatType?: string    //栖息地类型 (两爬样线用)
    vegetationType?: string //植被类型 (两爬样线用)
    ageLever?: string     //虫龄
    host?: string           //寄主
    characteristics?: string  //习性及特征
    humanActivityInterfereType?: string
    humanActivityInterfereSubType?: string
    humanActivityInterfereRate?: string
    tableIndex?: number  //植被样点用
}

interface BjTypeSpeceisNameRow {
    id?: string
    family?: string
    family_c?: string
    genus?: string
    genus_c?: string
    species_c?: string
    canorical_me?: string
    Common_name?: string
    pinyin_species_c?: string
    pinyin_Common_name?: string
    family_ID?: string
    type?: string
};

interface BjTypeActualMeasurementResearchTableRow {
    id?: string
    researchId?: string
    serialNumberAndCode?: string
    layerType?: 'arbor' | 'shrub' | 'plant' | 'moss' | 'other'
    extraLayerType: 'small-tree' | 'small-seedling' | 'unset'
    tabIndex?: string
    speciesName?: string
    breastDiameter?: string
    heightUnderBranch?: string
    amplitudeCrown?: string
    amplitudeCrownLong?: string
    amplitudeCrownWidth?: string
    health?: string
    rootPartHabitat?: string  //
    isFlower?: string
    isFruit?: string
    numberOfClusters?: string  //丛数
    numberOfPlants?: string  //株数
    groundDiameter?: string  //地径cm
    plantHeight?: string  //高度
    averageCrownWidth?: string //平均冠幅
    coverage?: string  //盖度
    plantNumberSoilSurface?: string  //株数-土面 
    plantNumberStoneDitch?: string  //株数-石沟
    plantNumberStoneSurface?: string  //株数-石面 
    plantNumberHealth?: string  //株数-健康
    plantNumberSubHealth?: string  //株数-亚健康 
    plantNumberMediumHealth?: string  //株数-中健康 
    plantNumberNotHealth?: string  //株数-不健康 
    plantNumberIsFlower?: string   //株数-开花
    plantNumberIsFruit?: string   //株数-结果
    plantNumberRockEpiphyte?: string   //岩石附生
    plantNumberBranchEpiphyte?: string  //枝干附生
    plantNumberOtherType?: string  //具孢蒴或孢子囊植株数
    minGroundDiameter?: string   //最小地径
    averageGroundDiameter?: string   //平均地径
    maxGroundDiameter?: string  //最大地径
    minPlantHeight?: string   //最小地径
    averagePlantHeight?: string   //平均地径
    maxPlantHeight?: string  //最大地径
    remark?: string
    imageList?: string
    voiceList?: string
    altitude?: number
    longitude?: string | number
    latitude?: string | number
    createDate?: number
    editDate?: number
    geoType?: 'WGS-84' | 'GCJ-02'
    isLocalDelete?: '0' | '1'
    createUserId?: string
    createUserName?: string
};

interface BjTypeSampleSquareResearchTableRow {
    id?: string
    researchId?: string
    serialNumberAndCode?: string
    layerType?: 'arbor' | 'shrub' | 'plant' | 'moss' | 'other'
    extraLayerType: 'small-tree' | 'small-seedling' | 'unset'
    tabIndex?: string
    speciesName?: string
    breastDiameter?: string
    heightUnderBranch?: string
    amplitudeCrown?: string
    amplitudeCrownLong?: string
    amplitudeCrownWidth?: string
    health?: string
    rootPartHabitat?: string  //
    isFlower?: string
    isFruit?: string
    numberOfClusters?: string  //丛数
    numberOfPlants?: string  //株数
    groundDiameter?: string  //地径cm
    plantHeight?: string  //高度
    averageCrownWidth?: string //平均冠幅
    coverage?: string  //盖度
    plantNumberSoilSurface?: string  //株数-土面 
    plantNumberStoneDitch?: string  //株数-石沟
    plantNumberStoneSurface?: string  //株数-石面 
    plantNumberHealth?: string  //株数-健康
    plantNumberSubHealth?: string  //株数-亚健康 
    plantNumberMediumHealth?: string  //株数-中健康 
    plantNumberNotHealth?: string  //株数-不健康 
    plantNumberIsFlower?: string   //株数-开花
    plantNumberIsFruit?: string   //株数-结果
    plantNumberRockEpiphyte?: string   //岩石附生
    plantNumberBranchEpiphyte?: string  //枝干附生
    plantNumberOtherType?: string  //具孢蒴或孢子囊植株数
    minGroundDiameter?: string   //最小地径
    averageGroundDiameter?: string   //平均地径
    maxGroundDiameter?: string  //最大地径
    minPlantHeight?: string   //最小地径
    averagePlantHeight?: string   //平均地径
    maxPlantHeight?: string  //最大地径
    remark?: string
    imageList?: string
    voiceList?: string
    altitude?: number
    longitude?: string | number
    latitude?: string | number
    createDate?: number
    editDate?: number
    geoType?: 'WGS-84' | 'GCJ-02'
    isLocalDelete?: '0' | '1'
    createUserId?: string
    createUserName?: string
};

interface BjTypeSampleLineResearchTableRow {
    id?: string
    researchId?: string
    serialNumberAndCode?: string
    layerType?: 'arbor' | 'shrub' | 'plant' | 'moss' | 'other'
    extraLayerType: 'small-tree' | 'small-seedling' | 'unset'
    tabIndex?: string
    speciesName?: string
    breastDiameter?: string
    heightUnderBranch?: string
    amplitudeCrown?: string
    amplitudeCrownLong?: string
    amplitudeCrownWidth?: string
    health?: string
    rootPartHabitat?: string  //
    isFlower?: string
    isFruit?: string
    numberOfClusters?: string  //丛数
    numberOfPlants?: string  //株数
    groundDiameter?: string  //地径cm
    plantHeight?: string  //高度
    averageCrownWidth?: string //平均冠幅
    coverage?: string  //盖度
    plantNumberSoilSurface?: string  //株数-土面 
    plantNumberStoneDitch?: string  //株数-石沟
    plantNumberStoneSurface?: string  //株数-石面 
    plantNumberHealth?: string  //株数-健康
    plantNumberSubHealth?: string  //株数-亚健康 
    plantNumberMediumHealth?: string  //株数-中健康 
    plantNumberNotHealth?: string  //株数-不健康 
    plantNumberIsFlower?: string   //株数-开花
    plantNumberIsFruit?: string   //株数-结果
    plantNumberRockEpiphyte?: string   //岩石附生
    plantNumberBranchEpiphyte?: string  //枝干附生
    plantNumberOtherType?: string  //具孢蒴或孢子囊植株数
    minGroundDiameter?: string   //最小地径
    averageGroundDiameter?: string   //平均地径
    maxGroundDiameter?: string  //最大地径
    minPlantHeight?: string   //最小地径
    averagePlantHeight?: string   //平均地径
    maxPlantHeight?: string  //最大地径
    remark?: string
    imageList?: string
    voiceList?: string
    altitude?: number
    longitude?: string | number
    latitude?: string | number
    createDate?: number
    editDate?: number
    geoType?: 'WGS-84' | 'GCJ-02'
    isLocalDelete?: '0' | '1'
    createUserId?: string
    createUserName?: string
};


interface BjTypeFrequencyTableRow {
    id?: string
    researchId?: string
    layerType?: 'arbor' | 'shrub' | 'plant' | 'moss'
    extraLayerType?: 'small-tree' | 'small-seedling' | 'unset'
    speciesName?: string
    frequencyValue?: string
    createDate?: string
    isLocalDelete?: '0' | '1'
}

interface BjTypeSpeciesBookTableRow {
    id?: string
    researchId?: string
    layerType?: 'arbor' | 'shrub' | 'plant' | 'moss'
    extraLayerType?: 'small-tree' | 'small-seedling' | 'unset'
    speciesName?: string
    dispatchArea?: string  //分布面积
    locationTag?: string   //定位标记 多选+填写 | 固定标桩；永久磁铁；目的物种树干油漆标记；毗邻岩石油漆标记  
    dispatchLayer?: string  //分布层 多选   | 乔木层（林冠层）；下木层；灌木层；草本层；地被层；层间层 
    dispatchType?: string  //分布方式 |   随机型；集群型；均匀型
    liveType?: string   //生活型 多选 | 乔木；灌木；草本；藤本；常绿；落叶；一年生；多年生；木质；肉质
    updateType?: string  //更新方式 多选  | 种子实生；无性繁殖（如萌生、分蘖）；种子实生为主；无性繁殖为主
    mainThreatenFactors?: string   //多选+填写 主要威胁因素  | 生境退化或丧失；直接采挖或砍伐；自然灾害；环境污染；外来生物入侵；本地物种竞争；病虫害；自身特性限制
    peopleUseType?: string  //多选+填写  | 用材；药用；薪柴；观赏；食用；特殊用途：
    humanActivityType?: string  //人为干扰方式  | 采挖；砍伐；修枝；剥皮；开垦；修路；水库；旅游；城镇化；火灾；放牧；狩猎；开矿；污染；    
    humanInterfereRate?: string //人为干扰强度  |  强、中、弱、无
    protectionUrgency?: string  //保护紧迫性
    //以下是未处理的字段
    actualMeasurementNumber?: string //实测点数量
    actualMeasurementSerialNumber?: string  //实测点编号
    speciesCenterLongitude?: string    //目的物种分布中心点GPS
    speciesCenterLatitude?: string     //目的物种分布中心点GPS
    speciesCenterAltitude?: string     //目的物种分布中心点GPS
    mainSampleSquareNumber?: string    //主样方(圆)数量
    mainSampleSquareSerialNumber?: string    //主样方(圆)编号
    mainSampleLineNumber?: string            //样线(带)数量
    mainSampleLineSerialNumber?: string      //样线(带)编号
    createDate?: string
    isLocalDelete?: '0' | '1'
}

interface BjTypeProtectionLandNameRow {
    id?: string
    protectionLandName?: string
    protectionLandCity?: string
    protectionLandCounty?: string
    protectionLandType?: string
    protectionLandLevel?: string
}

interface BjTypeFastRecordV1 {
    id?: string
    type?: "humanActivity" | "naturalDisaster" | "speciesDistribution" | "workPhoto"
    title?: string
    imageList?: Array<{
        url?: string
    }> & any
    voiceList?: Array<{
        voiceUrl: string
        voiceLocalUri: string
        voiceDuration: string
        id?: string

    }> & any
    speciesName?: string  //物种名称
    speciesType?: string
    speciesCount?: number //数量 
    microHabitat?: string
    remark?: string       //备注  
    customAddress?: string
    createDate?: Number
    createUserId?: number | string
    createUserName?: string
    specimenAcquisitionNumber?: string //标本采集号
    serialNumber?: string  //编号
    updateDate?: number
    altitude?: any
    latitude?: any
    longitude?: any
    locationPoiAddress?: string
    groupId?: number
    interferenceType?: string
    interferenceRate?: string
    photoTag?: string
    url?: string  //图片库展示用
    extra?: string,
    isLocalDelete?: '0' | '1'
}

type BjTypeDrawerContent = 'map-tool' | 'tool-box' | 'data-filter' | 'baike-info' | 'research-filter' | 'research-setting' | 'project-filter'
    | 'interfere-type' | 'fast-record-filter' | 'fast-record-multiple-data' | 'fast-record-multiple-tabs'
    | 'fast-record-data-export'

interface BjTypeMapMarker {
    id: string
    researchType: BjTypeResearchNameDict
    serialNumberAndCode: string
    latitude: number
    longitude: number
    rowList?: Array<Array<Number>>
    imageList?: Array<BjTypeImage>
}

export {
    BjTypeLocation,
    BjTypeSheetOption,
    BjTypeImage,
    BjTypeActualMeasurementResearch,
    BjTypeCommunityProfileResearch,
    BjTypeAppConfig,
    BjTypeCommonResearch,
    BjTypeUserMsg,
    BjTypeResearchNameDict,
    BjTypeResearchConnection,
    BjTypeTabRoute,
    BjTypeTableHeaderConfigCell,
    BjTypeVoice,
    BjTypeResearchAuthResult,
    TypeBirdResearchLineV1,
    TypeBirdResearchLineTableRowV1,
    BjTypeSpeceisNameRow,
    BjTypeActualMeasurementResearchTableRow,
    BjTypeSampleSquareResearch,
    BjTypeSampleLineResearch,
    BjTypeSampleSquareResearchTableRow,
    BjTypeSampleLineResearchTableRow,
    BjTypeFrequencyTableRow,
    BjTypeSpeciesBookTableRow,
    BjTypeProtectionLandNameRow,
    BjTypeFastRecordV1,
    BjTypeMapConfig,
    BjTypeDrawerContent,
    BjTypeMapMarker
}